; 
; IDL Event Callback Procedures
; moviePlayerWidget_eventcb
; 
; Generated on:	10/30/2005 20:58.21
; 
; 
; Empty stub procedure used for autoloading.
; 
pro moviePlayerWidget_eventcb
end
;-----------------------------------------------------------------
; Notify Realize Callback Procedure.
; Argument:
;   wWidget - ID number of specific widget.
;   
;   
;   Retrieve the IDs of other widgets in the widget hierarchy using 
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro moviePlayer_Realize, wWidget, data=data
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;   
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;   
;   ID is the widget ID of the component generating the event. TOP is 
;       the widget ID of the top level widget containing ID. HANDLER 
;       contains the widget ID of the widget associated with the 
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released. 
;       Normal buttons do not generate events when released, so 
;       SELECT will always be 1. However, toggle buttons (created by 
;       parenting a button to an exclusive or non-exclusive base) 
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using 
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro moviePlayer_Reverse, Event
  print,'<moviePlayer_Reverse>'
  wait,.1
  id = widget_info(Event.top, FIND_BY_UNAME='moviePlayerBase')
  widget_control,id,get_uvalue = dataInfo
  if (dataInfo.mode eq 2) then return ; already going in reverse
  dataInfo.mode = 2
  widget_control,id,set_uvalue = dataInfo
  rateSlider = widget_info(Event.top, FIND_BY_UNAME='frameRateSlider')
  wset,dataInfo.window
  frame = dataInfo.frame
  widget_control,rateSlider,get_value = rate
  nframes = (size(dataInfo.data))[3]
  while 1 do begin
      tv,dataInfo.data[*,*,frame]
      frame--
      if (frame lt 0) then frame = nframes-1
      wait,1./rate
      dataInfo.frame = frame
      widget_control,id,set_uvalue = dataInfo
      ev = widget_event(/nowait)
      widget_control,rateSlider,get_value = rate
      widget_control,id,get_uvalue = dataInfo
      if (dataInfo.mode ne 2) then break
      print,'<moviePlayer_Reverse> frame =',frame
  endwhile
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;   
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;   
;   ID is the widget ID of the component generating the event. TOP is 
;       the widget ID of the top level widget containing ID. HANDLER 
;       contains the widget ID of the widget associated with the 
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released. 
;       Normal buttons do not generate events when released, so 
;       SELECT will always be 1. However, toggle buttons (created by 
;       parenting a button to an exclusive or non-exclusive base) 
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using 
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro moviePlayer_Forward, Event
  print,'<moviePlayer_Forward>'
  wait,.1
  id = widget_info(Event.top, FIND_BY_UNAME='moviePlayerBase')
  widget_control,id,get_uvalue = dataInfo
  if (dataInfo.mode eq 1) then return ; already going forward
  dataInfo.mode = 1
  widget_control,id,set_uvalue = dataInfo
  rateSlider = widget_info(Event.top, FIND_BY_UNAME='frameRateSlider')
  wset,dataInfo.window
  frame = dataInfo.frame
  widget_control,rateSlider,get_value = rate
  nframes = (size(dataInfo.data))[3]
  while 1 do begin
      tv,dataInfo.data[*,*,frame]
      frame++
      if (frame eq nframes) then frame = 0
      wait,1./rate
      dataInfo.frame = frame
      widget_control,id,set_uvalue = dataInfo
      ev = widget_event(/nowait)
      widget_control,rateSlider,get_value = rate
      widget_control,id,get_uvalue = dataInfo
      if (dataInfo.mode ne 1) then break
      print,'<moviePlayer_Forward> frame = ',frame
  endwhile
end
;-----------------------------------------------------------------
; Activate Button Callback Procedure.
; Argument:
;   Event structure:
;   
;   {WIDGET_BUTTON, ID:0L, TOP:0L, HANDLER:0L, SELECT:0}
;   
;   ID is the widget ID of the component generating the event. TOP is 
;       the widget ID of the top level widget containing ID. HANDLER 
;       contains the widget ID of the widget associated with the 
;       handler routine.

;   SELECT is set to 1 if the button was set, and 0 if released. 
;       Normal buttons do not generate events when released, so 
;       SELECT will always be 1. However, toggle buttons (created by 
;       parenting a button to an exclusive or non-exclusive base) 
;       return separate events for the set and release actions.

;   Retrieve the IDs of other widgets in the widget hierarchy using 
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro moviePlayer_Pause, Event
  print,'<moviePlayer_Pause>'
  wait,.1
  id = widget_info(Event.top, FIND_BY_UNAME='moviePlayerBase')
  widget_control,id,get_uvalue = dataInfo
  dataInfo.mode = 0
  widget_control,id,set_uvalue = dataInfo
end
;-----------------------------------------------------------------
; Slider Value Changed Callback Procedure.
; Argument:
;   Event structure:
;   
;   {WIDGET_SLIDER, ID:0L, TOP:0L, HANDLER:0L, VALUE:0L, DRAG:0}
;   
;   ID is the widget ID of the component generating the event. TOP is 
;       the widget ID of the top level widget containing ID. HANDLER 
;       contains the widget ID of the widget associated with the 
;       handler routine.

;   VALUE returns the new value of the slider. DRAG returns integer 1 
;       if the slider event was generated as part of a drag 
;       operation, or zero if the event was generated when the user 
;       had finished positioning the slider.

;   Retrieve the IDs of other widgets in the widget hierarchy using 
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro moviePlayer_SetFrameRate, Event

end
;-----------------------------------------------------------------
; Post Create Widget Procedure.
; Argument:
;   wWidget - ID number of specific widget.
;   
;   Any keywords passed into the generated widget creation procedure 
;       are passed into this procudure.

;   Retrieve the IDs of other widgets in the widget hierarchy using 
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro moviePlayer_Create, wWidget, data=data, _EXTRA=_VWBExtra_
  n = (size(data))[1]
  m = (size(data))[2]
  nframes = (size(data))[3]
  n_display = 500
  if (n lt n_display) then begin
      mag = n_display/n
      n_display = n*mag
      m_display = m*mag
  endif else begin
      demag = n/n_display
      n_display = n/demag
      m_display = m/demag
  endelse
  data_display = fltarr(n_display,m_display,nframes)
  for k=0,nframes-1 do begin
      data_display[*,*,k] = rebin(data[*,*,k],n_display,m_display,/sample)
  endfor
  data_display -= min(data_display)
  data_display *= 255./max(data_display)
  window,/free,xsize=n_display,ysize=m_display
  win = !d.window
  tv,data_display[*,*,0]

  dataInfo = {data:data_display, window:win, frame:0, mode:0}
;  modes: 0-pause, 1-forward, 2-reverse
  widget_control,wWidget,set_uvalue = dataInfo
end
